
volatile bool iwdg_t2;

u8 Bta_pow;

extern "C"
{
 INTERRUPT_HANDLER(TIM2_UPD_OVF, 13)
 {
  SCR_OFF;

  iwdg_t2 = true;
  TIM2->SR1 = 0;
 }

 INTERRUPT_HANDLER(TIM2_CAPCOM,  14)
 {
  const u16 min_capt_val    = (u16)((u32)mcu_freq/16/65);
  const u8 pow_table[10][2] = {
                               {0,1 }, // 0%
                               {1,5 }, //20%
                               {1,3 }, //30%
                               {2,5 }, //40%
                               {1,2 }, //50%
                               {3,5 }, //60%
                               {5,7 }, //71%
                               {4,5 }, //80%
                               {9,10}, //90%
                               {1,1 }  //100%
                              };
  static u16 capt_val;

  capt_val   = (u16)TIM2->CCR1H << 8;
  capt_val  += TIM2->CCR1L;

  if(capt_val > min_capt_val)
  {
   static bool wave_trg;

   TIM2->EGR = TIM2_EGR_UG;
   SCR_OFF;

   if(wave_trg == false) wave_trg = true;
   else
   {
    static u8 ccnt_on;
    static u8 ccnt_all;

    wave_trg = false;

    if(!ccnt_all)
    {
     ccnt_on  = pow_table[Bta_pow][0];
     ccnt_all = pow_table[Bta_pow][1];
    }

    ccnt_all--;

    if(ccnt_on)
    {
     ccnt_on--;
     SCR_ON;
    }
   }
  }

  iwdg_t2 = true;
  TIM2->SR1 = 0;
 }
}