const u8 Eep_storage_size = 40;

struct
{
 u8 init;
 u8 motor_voltage;
 u8 n_motor_voltage;

 u8 airflow[Eep_storage_size];
 u8 heatpow[Eep_storage_size];
 u8 onoff  [Eep_storage_size];

}eep @ ".eeprom.noinit";

class
{
 public:

 void gpio()
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;
  PA_DDR = 1<<3;

  PB_CR1 = 0xff;
  PB_ODR = 0;
  PB_DDR = 0xff;

  PC_CR1 = 0xff;
  PC_ODR = 1<<1;
  PC_DDR = 1<<7|1<<4|1<<1;

  PD_CR1 = 0xff - (1<<4);
  PD_ODR = 0;
  PD_DDR = 1<<3|1<<2;

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0;
  PF_DDR = 0xff;
 }
 void clk()
 {
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM2|CLK_PCKENR1_TIM4;
  CLK->PCKENR2 = 0;
  CLK->CKDIVR  = 0;
 }
 void t1()
 {
  TIM1->ARRH  = 0;
  TIM1->ARRL  = 0xff;

  TIM1->PSCRL = 3;

  TIM1->CCER1 = TIM1_CCER1_CC1E;
  TIM1->CCMR1 = pwm2;

  TIM1->CCR1H = 0;
  TIM1->CCR1L = 0xff;

  TIM1->BKR   = TIM1_BKR_MOE|3;
  TIM1->CR1   = TIM1_CR1_CEN;
 }
 void t2()
 {
  TIM2->PSCR  = 4;                           //16MHz/16 -> 10000     10ms
  TIM2->CCMR1 = TIM2_ICSELECTION_DIRECTTI |  //input mapped -      
                bin(11)<<4;                  // 

  TIM2->CCER1 = TIM2_CCER1_CC1E; //    

  TIM2->IER   = TIM2_IER_CC1IE|TIM2_IER_UIE;

  TIM2->CR1   = TIM2_CR1_CEN;
 }
 void t4()
 {
  TIM4->ARR   = mcu_freq/128/1000-1;
  TIM4->PSCR  = 7;
  TIM4->CR1   = 1;
 }
 void iwdg()
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_128);
  IWDG_SetReload(0xff);
  IWDG_ReloadCounter();
 }

 void change_options(void)
 {
  #define OPT2_ADDR 0x4803

  if(FLASH_ReadOptionByte(OPT2_ADDR)>>8 != 1<<1)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   FLASH_EraseOptionByte(OPT2_ADDR);
   FLASH_ProgramOptionByte(OPT2_ADDR, 1<<1); //    
   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 }

 void ee()
 {
  #define initval 0x2f

  if(eep.init != initval)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);

   for(u8 i=1; i<Eep_storage_size; i++)
   {
    eep.airflow[i] = 0xff;
    eep.heatpow[i] = 0xff;
    eep.onoff  [i] = 0xff;
   }

   eep.motor_voltage   = 22;
   eep.n_motor_voltage = ~eep.motor_voltage;

   eep.airflow[0] = 9;
   eep.heatpow[0] = 5;
   eep.onoff[0]   = 1;

   eep.init = initval;

   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 }
}cfg;

