const u8 max_pow = 9;
u8 max_pwm = 0xff/10;
u8 min_pwm = max_pwm/4;

u8 get_ee_motor_voltage(void)
{
 u8 a = eep.n_motor_voltage;
 a = ~a;
 if(eep.motor_voltage == a) return eep.motor_voltage;
 else return 18;
}

void get_pwm_constraints(void)
{
 u8 tmp;

 tmp = get_ee_motor_voltage();

 max_pwm = (u16)0xff * tmp / 220;
 min_pwm = max_pwm / 4;

 if(min_pwm < 5) min_pwm = 5;
}

void set_vent_pow (u8 pow_level)
{
 if(pow_level > max_pow) pow_level = max_pow;

 TIM1->CCR1L = (max_pwm - min_pwm) * pow_level /max_pow + min_pwm;
}

bool check_pwm_reg(void)
{
 if(TIM1->CCR1L >= min_pwm &&
    TIM1->CCR1L <= max_pwm &&
    TIM1->CCR1H == 0) return true;

 return false;
}